// Copyright Epic Games, Inc. All Rights Reserved.

#include "DDPopul8.h"
#include "Misc/Paths.h"
#include "ShaderCore.h"
#include "Interfaces/IPluginManager.h"

#define LOCTEXT_NAMESPACE "FPopul8Module"

DEFINE_LOG_CATEGORY(LogDidimo);

void FDDPopul8Module::StartupModule()
{
	// Register the shader directory for the plugin
	FString PluginBaseDir = IPluginManager::Get().FindPlugin(TEXT("Popul8"))->GetBaseDir();
	FString PluginShaderDir = FPaths::Combine(PluginBaseDir, TEXT("Shaders"));
	AddShaderSourceDirectoryMapping(TEXT("/Plugin/Popul8"), PluginShaderDir);
}

void FDDPopul8Module::ShutdownModule()
{
	// This function may be called during shutdown to clean up your module.  For modules that support dynamic reloading,
	// we call this function before unloading the module.
}

#undef LOCTEXT_NAMESPACE
	
IMPLEMENT_MODULE(FDDPopul8Module, Popul8)