// Fill out your copyright notice in the Description page of Project Settings.

#include "Models/DDMorphShapingModel.h"
#include "DataAssets/DDDataAssets.h"
#include "Animation/MorphTarget.h"
#include "Rendering/SkeletalMeshRenderData.h"
#include "Rendering/SkeletalMeshLODRenderData.h"
#include "Rendering/PositionVertexBuffer.h"
#include "Rendering/StaticMeshVertexBuffer.h"
#include "Rendering/SkeletalMeshLODModel.h"
#include "Rendering/SkeletalMeshModel.h"
#include "Rendering/Texture2DResource.h"
#include "Engine/SkinnedAssetCommon.h"
#include "Engine/Texture2D.h"
#include "RHI.h"
#include "RenderResource.h"
#include "TextureResource.h"
#include <cmath>


void UDDMorphShapingModel::Initialize(UDDCharacterEditorConfigData* Config, USkeletalMesh* MorphableMesh)
{
    MarkedDirty = true;

    if (!MorphableMesh)
    {
        UE_LOG(LogTemp, Warning, TEXT("MorphableMesh is null!"));
        return;
    }

    const TArray<UMorphTarget*>& MorphTargets = MorphableMesh->GetMorphTargets();
    for (size_t i = 0; i < MorphTargets.Num(); i++)
    {
        Weights.Add(MorphTargets[i]->GetName(), 0.0f);
    }
}

