// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Models/DDMorphShapingModel.h"
#include "DDMorphShapingController.generated.h"


//
// Morph Target Controller
//

UCLASS(BlueprintType)
class POPUL8_API UDDMorphShapingController : public UObject
{
    GENERATED_BODY()

public:
	void Initialize(UDDCharacterEditorConfigData* Config);
	void SetModel(UDDMorphShapingModel* Model);

	void ResetToConfigValues();
	void Randomize();

	void UpdateModel(
		const struct FDDShapeConstraints* ShapeConstraints,
		int i0, float v0, int i1 = -1, float v1 = 0.0f);

	void ApplyChanges(class UDDEditableSkeletalMeshComponent* SkeletalMeshComponent);

private:
	UPROPERTY()
	UDDCharacterEditorConfigData* Configuration;

	UPROPERTY()
	UDDMorphShapingModel* ModelToControl;
};

