#pragma once

#include "CoreMinimal.h"
#include "DDImageProcessor.h"
#include "DDBlendTexture.generated.h"


UENUM(BlueprintType)
enum EDDBlendTextureDependencySlot : int32
{
    BTDS_InputTexture_A         UMETA(DisplayName = "InputTexture_A"),
    BTDS_InputTexture_B         UMETA(DisplayName = "InputTexture_B"),
    BTDS_MaskTexture            UMETA(DisplayName = "MaskTexture"),
};

UENUM(BlueprintType)
enum EDDBlendTextureOperation : int32
{
    BTO_Add                 UMETA(DisplayName = "Add"),
    BTO_Mul                 UMETA(DisplayName = "Mul"),
    BTO_Lerp                UMETA(DisplayName = "Lerp"),
};

UCLASS()
class POPUL8_API UDDBlendTexture : public UDDependantImageProcessor
{
    GENERATED_BODY()

public:
    void SetWeight(float Weight);
    void SetOperation(EDDBlendTextureOperation Operation);

protected:
    virtual void Execute(DDImageProcessorExecuteContext_GameThread& context) override;
    virtual void Execute(DDImageProcessorExecuteContext_RenderThread& context) override;

private:
    float CurrentWeight{ 1.0f };
    EDDBlendTextureOperation CurrentOp{ EDDBlendTextureOperation::BTO_Lerp };
};