#pragma once

#include "CoreMinimal.h"
#include "DDImageProcessor.h"
#include "DDImageTexture.generated.h"


UCLASS()
class POPUL8_API UDDImageTexture : public UDDImageProcessor
{
    GENERATED_BODY()

public:
    void SetInputTexture(UTexture2D* Input);
    void SetScaleAndOffset(const FVector2f& BlitScale, const FVector2f& BlitOffset);

protected:
    virtual void Prepare() override;
    virtual void Execute(DDImageProcessorExecuteContext_GameThread& context) override;
    virtual void Execute(DDImageProcessorExecuteContext_RenderThread& context) override;

private:
    UPROPERTY()
    UTexture2D* InputTexture;
    bool bNeedToUpdateTextureResource;

    FVector2f Scale{ FVector2f::One() };
    FVector2f Offset{ FVector2f::Zero() };
};