#pragma once

#include "CoreMinimal.h"
#include "DDImageProcessor.h"
#include "DDMeshUVColor.generated.h"


UCLASS()
class POPUL8_API UDDMeshUVColor : public UDDImageProcessor
{
    GENERATED_BODY()

public:
    virtual ~UDDMeshUVColor();

    void setUVsAndColors(const TArray<FVector2f>& uvs, const TArray<FColor>& colors);
    void setColorMultiplier(const FColor& colorMultiplier);

protected:
    virtual void Execute(DDImageProcessorExecuteContext_GameThread& context) override;
    virtual void Execute(DDImageProcessorExecuteContext_RenderThread& context) override;

private:
    int32 SizeX, SizeY;
    FVector4f ColorMultiplier = { FColor::White };

    FBufferRHIRef UV_VB_RHI;
    TArray<FVector2f> UVs;

    FBufferRHIRef Color_VB_RHI;
    TArray<FVector4f> Colors;
};