#pragma once

#include "CoreMinimal.h"
#include "DDImageProcessor.h"
#include "DDMeshUVTexture.generated.h"


UCLASS()
class POPUL8_API UDDMeshUVTexture : public UDDependantImageProcessor
{
    GENERATED_BODY()

public:
    virtual ~UDDMeshUVTexture();

    void setUVs(const TArray<FVector2f>& uvs);
    void setColorMultiplier(const FColor& colorMultiplier);

protected:
    virtual void Execute(DDImageProcessorExecuteContext_GameThread& context) override;
    virtual void Execute(DDImageProcessorExecuteContext_RenderThread& context) override;

private:
    int32 SizeX, SizeY;
    FVector4f ColorMultiplier = { FColor::White };

    FBufferRHIRef VertexBufferRHI;
    TArray<FVector2f> UVs;
};