#pragma once

#include "CoreMinimal.h"
#include "DDImageProcessor.h"
#include "DDSwizzle.generated.h"


UENUM(BlueprintType)
enum EDDSwizzleChannel : int32
{
    SC_Zero     UMETA(DisplayName = "Zero"),

    SC_Red      UMETA(DisplayName = "Red"),
    SC_Green    UMETA(DisplayName = "Green"),
    SC_Blue     UMETA(DisplayName = "Blue"),
    SC_Alpha    UMETA(DisplayName = "Alpha"),

    SC_OneMinusRed      UMETA(DisplayName = "OneMinusRed"),
    SC_OneMinusGreen    UMETA(DisplayName = "OneMinusGreen"),
    SC_OneMinusBlue     UMETA(DisplayName = "OneMinusBlue"),
    SC_OneMinusAlpha    UMETA(DisplayName = "OneMinusAlpha"),

    SC_One      UMETA(DisplayName = "One"),
};

UCLASS()
class POPUL8_API UDDSwizzle : public UDDependantImageProcessor
{
    GENERATED_BODY()

public:
    void SetArrangement(
        EDDSwizzleChannel RChannelSource,
        EDDSwizzleChannel GChannelSource,
        EDDSwizzleChannel BChannelSource,
        EDDSwizzleChannel AChannelSource);

protected:
    virtual void Execute(DDImageProcessorExecuteContext_GameThread& context) override;
    virtual void Execute(DDImageProcessorExecuteContext_RenderThread& context) override;

private:
    EDDSwizzleChannel CurrentArrangement[4] = {
        EDDSwizzleChannel::SC_Red,
        EDDSwizzleChannel::SC_Green,
        EDDSwizzleChannel::SC_Blue,
        EDDSwizzleChannel::SC_Alpha,
    };
};