#pragma once

#include "CoreMinimal.h"
#include "DDKdTree.generated.h"


USTRUCT()
struct POPUL8_API FDDKdTree
{
	GENERATED_BODY()

	struct Node
	{
		int Index = -1;
		int Axis = -1;
		Node* ChildLeft = nullptr;
		Node* ChildRight = nullptr;
	};

	~FDDKdTree();

	TArray<FVector> Data;
	struct Node* Root = nullptr;
};


void BuildKdtree(FDDKdTree* Tree, const TArray<FVector>& Data);
void ClearKdtree(FDDKdTree* Tree);
void CollectFromKdtree(const FDDKdTree& Tree, const FVector& Center, float Radius, TArray<int>* Result);
int FindClosestInKdtree(const FDDKdTree& Tree, const FVector& Center);
void ValidateKdtree(const FDDKdTree& Tree);
void DumpKdTree(const FDDKdTree& Tree);
