// Fill out your copyright notice in the Description page of Project Settings.

#pragma once
#include "CoreMinimal.h"
#include "Engine/DataAsset.h"
#include "UObject/ObjectMacros.h"
#include "UObject/ScriptMacros.h"
#include "DataAssets/DDDataAssets.h"
#include "DataAssets/DDCharacterEditorSkinCompositionData.h"
#include "Controllers/DDMorphShapingController.h"
#include "Controllers/DDTextureEditingController.h"
#include "Models/DDMorphShapingModel.h"
#include "Models/DDTextureEditingModel.h"
#include "DDVertexCacheData.generated.h"


UCLASS(BlueprintType)
class POPUL8_API UDDAttachmentVertexCacheData : public UDataAsset
{
	GENERATED_BODY()

public:
	void BuildData();

private:
	bool LoadBinaryFloats(const FString& FilePath, TArray<float>& OutFloats);

public:
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Didimo")
	TArray<float> VertexOpacity;

	// The skeletal mesh that will be culled using this data
	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Didimo")
	USkeletalMesh* TargetSkeletalMesh;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Didimo")
	FString BinFileDirectory;
};