// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Engine/SkeletalMesh.h"
#include "DDMorphShapingModel.generated.h"


//
// Morph Target Model
//

UCLASS(BlueprintType)
class POPUL8_API UDDMorphShapingModel : public UObject
{
    GENERATED_BODY()

	friend class UDDMorphShapingController;
	friend class UDDModelSerializer;

public:
	void Initialize(class UDDCharacterEditorConfigData* Config, USkeletalMesh* MorphableMesh);
	bool IsMarkedDirty() const { return MarkedDirty; }

private:
	bool MarkedDirty;

	TMap<FString, float> Weights;
};

