// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Views/DDCharacterEditorSliders.h"
#include "Blueprint/UserWidget.h"
#include "Components/ExpandableArea.h"
#include "Components/Slider.h"
#include "DDCharacterEditorExpandableArea.generated.h"

/**
 * 
 */
UCLASS()
class POPUL8_API UDDCharacterEditorExpandableArea : public UExpandableArea
{
	GENERATED_BODY()
	
	friend class UDDCharacterEditorWidget;

public:
	void Initialize(const FString& HeaderText);
	void AddBoneShapingSlider(
		const FDDCharacterEditorSegmentation& Segmentation,
		const FDDTransformConstraint& TransformConstraint);

	void AddShapeConstraintsSlider(
		const FDDShapeConstraints& ShapeConstraints);

	void AddSkinCompositingHandler(
		const FDDCharacterEditorSegmentation& Segmentation,
		const FDDCharacterEditorSkinCompositionHandler& Handler);

protected:
	class UVerticalBox* GetBodyAsVerticalBox();

private:
	//class UDDBoneShapingController* BoneShapingController;
	class UDDMorphShapingController* MorphShapingController;
	class UDDTextureEditingController* TextureEditingController;

	TSubclassOf<UDDCharacterEditor1DSlider> DDCharacterEditor1DSliderClass;
	TSubclassOf<UDDCharacterEditor2DSlider> DDCharacterEditor2DSliderClass;
	TSubclassOf<UDDCharacterEditorPolygonSlider> DDCharacterEditorPolygonSliderClass;

	TArray<UDDCharacterEditor2DSlider*> CE2DSliders;
};

