// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Blueprint/UserWidget.h"
#include "Components/VerticalBox.h"
#include "Views/DDCharacterEditorSliders.h"
#include "Views/DDCharacterEditorExpandableArea.h"
#include "ActorComponents/DDEditableSkeletalMeshComponent.h"
#include "DDCharacterEditorWidget.generated.h"

/**
 * 
 */
UCLASS()
class POPUL8_API UDDCharacterEditorWidget : public UUserWidget
{
	GENERATED_BODY()
	
public:
	virtual void NativeConstruct() override;

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Didimo")
	UDDEditableSkeletalMeshComponent* DDSkeletalMeshComponent;

protected:
	UDDCharacterEditorExpandableArea* getOrCreateExpandableArea(const FString& name);

protected:
    UPROPERTY(meta = (BindWidget))
    UVerticalBox* SettingsList;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Didimo")
	TSubclassOf<UDDCharacterEditor1DSlider> DDCharacterEditor1DSliderClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Didimo")
	TSubclassOf<UDDCharacterEditor2DSlider> DDCharacterEditor2DSliderClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Didimo")
	TSubclassOf<UDDCharacterEditorPolygonSlider> DDCharacterEditorPolygonSliderClass;

	UPROPERTY()
	TMap<FString, UDDCharacterEditorExpandableArea*> ExpandableAreasMap;
};
