#include "DDBridgeUtils.h"

FString UDDBridgeUtils::PathSanitizer(const FString& Path)
{
    // Remove invalid characters
    FString SanitizedPath = Path;
    const TCHAR* InvalidChars = TEXT("<>\"|?*.[]#");
    for (const TCHAR* Char = InvalidChars; *Char; ++Char)
    {
        SanitizedPath.ReplaceInline(*FString::Chr(*Char), TEXT(""));
    }

    // Replace blank spaces with underscores
    SanitizedPath.ReplaceInline(TEXT(" "), TEXT("_"));

    // Normalize the path
    //SanitizedPath = FPaths::ConvertRelativePathToFull(SanitizedPath);
    FPaths::NormalizeDirectoryName(SanitizedPath);

    return SanitizedPath;
}

FString UDDBridgeUtils::NameSanitizer(const FString& Name)
{
    FString SanitizedName = Name;
    int32 DotIndex;
    if (SanitizedName.FindChar(TEXT('.'), DotIndex))
    {
        return SanitizedName.Left(DotIndex);
    }
    return PathSanitizer(SanitizedName);
}
