// Copyright Epic Games, Inc. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleManager.h"
#include "DataAssets/DDDataAssets.h"
#include "DataAssets/DDCharacterEditorSkinCompositionData.h"

class UDDAttachmentVertexCacheData;

class FDDPopul8EditorModule : public IModuleInterface
{
public:

	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	static UDDAttachmentVertexCacheData* CreateGarmentCullingCacheData(
		const FString& BinFileDirectory,
		USkeletalMesh* TargetSkeletalMesh,
		const FString& DestinationDirectory);

private:
	void RegisterMenus();
	void OpenWindow();
	TSharedRef<SDockTab> CreatePluginTab(const FSpawnTabArgs& TabArgs);

	// Garment functions
	void SelectCullBin();
	void CreateGarmentCullingCacheData();

	// Bridge project export
	void SelectProjectExportFolder();

private:
	UDDAssetCatalogData* AssetCatalogData = nullptr;
	UDDCharacterEditorConfigData* SelectedCEConfigData = nullptr;
	UDDCharacterEditorSkinCompositionData* SkinCompositionEditorData = nullptr;

	USkeletalMesh* AnimationSkeletalMesh = nullptr;
	USkeletalMesh* MorphTargetsSkeletalMesh = nullptr;
	USkeletalMesh* BoneShapingSkeletalMesh = nullptr;

	// Garments and cull
	FString SelectedBinFileDirectory;	
	USkeletalMesh* TargetSkeletalMesh = nullptr;

	// Bridge project export
	FString SelectedProjectExportFolder;

};
